(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('nativescript-ui-calendar'), require('@nativescript/core'), require('@nativescript/angular')) :
    typeof define === 'function' && define.amd ? define('nativescript-ui-calendar-angular', ['exports', '@angular/core', 'nativescript-ui-calendar', '@nativescript/core', '@nativescript/angular'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["nativescript-ui-calendar-angular"] = {}, global.ng.core, global["ns-ui-calendar"], global["ns-core"], global["ns-angular"]));
})(this, (function (exports, core$1, nativescriptUiCalendar, core, angular) { 'use strict';

    var RadCalendarComponent = /** @class */ (function () {
        function RadCalendarComponent(_elementRef, _iterableDiffers) {
            this._elementRef = _elementRef;
            this._iterableDiffers = _iterableDiffers;
            this.doCheckDelay = 5;
            this._calendar = _elementRef.nativeElement;
        }
        Object.defineProperty(RadCalendarComponent.prototype, "eventSource", {
            set: function (value) {
                this._eventSource = value;
                var needDiffer = true;
                if (value instanceof core.ObservableArray) {
                    needDiffer = false;
                }
                if (needDiffer && !this._differ && CollectionUtils.isListLikeIterable(value)) {
                    this._differ = this._iterableDiffers.find(this._eventSource).create(function (index, item) { return item; });
                }
                this._calendar.eventSource = this._eventSource;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadCalendarComponent.prototype, "nativeElement", {
            get: function () {
                return this._calendar;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadCalendarComponent.prototype, "calendar", {
            get: function () {
                return this._calendar;
            },
            enumerable: false,
            configurable: true
        });
        RadCalendarComponent.prototype.ngDoCheck = function () {
            if (this._differ) {
                var changes = this._differ.diff(this._eventSource);
                if (changes) {
                    this._calendar.reload();
                }
            }
        };
        return RadCalendarComponent;
    }());
    RadCalendarComponent.decorators = [
        { type: core$1.Component, args: [{
                    selector: 'RadCalendar',
                    template: ''
                },] }
    ];
    RadCalendarComponent.ctorParameters = function () { return [
        { type: core$1.ElementRef, decorators: [{ type: core$1.Inject, args: [core$1.ElementRef,] }] },
        { type: core$1.IterableDiffers, decorators: [{ type: core$1.Inject, args: [core$1.IterableDiffers,] }] }
    ]; };
    RadCalendarComponent.propDecorators = {
        eventSource: [{ type: core$1.Input }]
    };
    ////////////////////
    // Copied from angular 2 @angular/common/src/facade/collection
    var CollectionUtils;
    (function (CollectionUtils) {
        function isPresent(obj) {
            return obj !== undefined && obj !== null;
        }
        function isBlank(obj) {
            return obj === undefined || obj === null;
        }
        var _symbolIterator = null;
        var globalScope;
        function getSymbolIterator() {
            if (isBlank(_symbolIterator)) {
                if (isPresent(globalScope.Symbol) && isPresent(Symbol.iterator)) {
                    _symbolIterator = Symbol.iterator;
                }
                else {
                    // es6-shim specific logic
                    var keys = Object.getOwnPropertyNames(Map.prototype);
                    for (var i = 0; i < keys.length; ++i) {
                        var key = keys[i];
                        if (key !== 'entries' && key !== 'size' && Map.prototype[key] === Map.prototype['entries']) {
                            _symbolIterator = key;
                        }
                    }
                }
            }
            return _symbolIterator;
        }
        function isJsObject(o) {
            return o !== null && (typeof o === 'function' || typeof o === 'object');
        }
        function isArray(obj) {
            return Array.isArray(obj);
        }
        function isListLikeIterable(obj) {
            if (!isJsObject(obj))
                return false;
            return (isArray(obj) ||
                (!(obj instanceof Map) && // JS Map are iterables but return entries as [k, v]
                    getSymbolIterator() in obj)); // JS Iterable have a Symbol.iterator prop
        }
        CollectionUtils.isListLikeIterable = isListLikeIterable;
    })(CollectionUtils || (CollectionUtils = {}));
    ////////////////////
    var CALENDAR_DIRECTIVES = [RadCalendarComponent];
    angular.registerElement('RadCalendar', function () { return nativescriptUiCalendar.RadCalendar; });
    var NativeScriptUICalendarModule = /** @class */ (function () {
        function NativeScriptUICalendarModule() {
        }
        return NativeScriptUICalendarModule;
    }());
    NativeScriptUICalendarModule.decorators = [
        { type: core$1.NgModule, args: [{
                    declarations: [CALENDAR_DIRECTIVES],
                    exports: [CALENDAR_DIRECTIVES]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.CALENDAR_DIRECTIVES = CALENDAR_DIRECTIVES;
    exports.NativeScriptUICalendarModule = NativeScriptUICalendarModule;
    exports.RadCalendarComponent = RadCalendarComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=nativescript-ui-calendar-angular.umd.js.map
